"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrometheusClient = exports.N9NodeRouting = exports.N9Log = exports.getMetadataArgsStorage = exports.plainToClass = exports.classToPlain = exports.Expose = exports.Exclude = exports.Transform = exports.Type = exports.useContainer = exports.getFromContainer = exports.Container = exports.Service = exports.Inject = void 0;
require("reflect-metadata");
require("./utils/error-to-json");
const n9_node_conf_1 = require("@neo9/n9-node-conf");
const n9_node_log_1 = require("@neo9/n9-node-log");
const appRootDir = require("app-root-dir");
const class_transformer_1 = require("class-transformer");
const Path = require("path");
const PrometheusClient = require("prom-client");
exports.PrometheusClient = PrometheusClient;
const typedi_1 = require("typedi");
const ExpressApp = require("./express-app");
const init_apm_1 = require("./init-apm");
const init_conf_1 = require("./init-conf");
const initialise_modules_1 = require("./initialise-modules");
const N9NodeRouting = require("./models/routing");
const options_1 = require("./options");
const register_system_signals_1 = require("./register-system-signals");
const requestid_1 = require("./requestid");
const Routes = require("./routes");
const routes_1 = require("./routes");
const start_modules_1 = require("./start-modules");
const utils_1 = require("./utils");
const http_client_base_1 = require("./utils/http-client-base");
/* istanbul ignore next */
function handleThrow(err) {
    throw err;
}
__exportStar(require("@benjd90/routing-controllers"), exports);
var typedi_2 = require("typedi");
Object.defineProperty(exports, "Inject", { enumerable: true, get: function () { return typedi_2.Inject; } });
Object.defineProperty(exports, "Service", { enumerable: true, get: function () { return typedi_2.Service; } });
Object.defineProperty(exports, "Container", { enumerable: true, get: function () { return typedi_2.Container; } });
var class_validator_1 = require("class-validator");
Object.defineProperty(exports, "getFromContainer", { enumerable: true, get: function () { return class_validator_1.getFromContainer; } });
Object.defineProperty(exports, "useContainer", { enumerable: true, get: function () { return class_validator_1.useContainer; } });
__exportStar(require("class-validator"), exports);
var class_transformer_2 = require("class-transformer");
Object.defineProperty(exports, "Type", { enumerable: true, get: function () { return class_transformer_2.Type; } });
Object.defineProperty(exports, "Transform", { enumerable: true, get: function () { return class_transformer_2.Transform; } });
Object.defineProperty(exports, "Exclude", { enumerable: true, get: function () { return class_transformer_2.Exclude; } });
Object.defineProperty(exports, "Expose", { enumerable: true, get: function () { return class_transformer_2.Expose; } });
Object.defineProperty(exports, "classToPlain", { enumerable: true, get: function () { return class_transformer_2.classToPlain; } });
Object.defineProperty(exports, "plainToClass", { enumerable: true, get: function () { return class_transformer_2.plainToClass; } });
var routing_controllers_1 = require("@benjd90/routing-controllers");
Object.defineProperty(exports, "getMetadataArgsStorage", { enumerable: true, get: function () { return routing_controllers_1.getMetadataArgsStorage; } });
__exportStar(require("routing-controllers-openapi"), exports);
__exportStar(require("@neo9/n9-node-utils"), exports); // allow users to use n9-node-utils without importing it specifically
var n9_node_log_2 = require("@neo9/n9-node-log");
Object.defineProperty(exports, "N9Log", { enumerable: true, get: function () { return n9_node_log_2.N9Log; } });
__exportStar(require("./decorators/acl.decorator"), exports);
__exportStar(require("./validators"), exports);
__exportStar(require("./transformer"), exports);
__exportStar(require("./models/routes.models"), exports);
__exportStar(require("./utils/http-client-base"), exports);
__exportStar(require("./utils/http-cargo-builder"), exports);
__exportStar(require("./utils/cargo"), exports);
exports.N9NodeRouting = require("./models/routing");
// tslint:disable-next-line:cyclomatic-complexity
exports.default = async (optionsParam = {}) => {
    // Provides a stack trace for unhandled rejections instead of the default message string.
    process.on('unhandledRejection', handleThrow);
    // Options default
    const environment = (0, utils_1.getEnvironment)();
    // eslint-disable-next-line @typescript-eslint/no-var-requires,global-require,import/no-dynamic-require
    const packageJson = require(Path.join(appRootDir.get(), 'package.json'));
    let conf = (0, n9_node_conf_1.default)((0, options_1.getLoadingConfOptions)(optionsParam));
    const options = (0, options_1.mergeOptionsAndConf)(optionsParam, conf.n9NodeRoutingOptions);
    (0, options_1.applyDefaultValuesOnOptions)(options, environment, packageJson.name);
    const logger = options.log;
    // print app infos
    const initialInfos = `${conf.name} version : ${conf.version} env: ${conf.env} node: ${process.version}`;
    logger.info('-'.repeat(initialInfos.length));
    logger.info(initialInfos);
    logger.info('-'.repeat(initialInfos.length));
    // Profile startup boot time
    logger.profile('startup');
    if (options.enableRequestId) {
        options.log.addFilter(requestid_1.requestIdFilter);
    }
    const confInstance = await (0, init_conf_1.validateConf)(conf, options.conf.validation, logger);
    conf = confInstance || conf;
    (0, routes_1.initExposedConf)((0, class_transformer_1.classToPlain)(conf));
    typedi_1.Container.set(n9_node_log_1.N9Log, logger);
    if (options.conf.validation.classType) {
        typedi_1.Container.set(options.conf.validation.classType, conf);
    }
    else {
        typedi_1.Container.set('conf', conf);
    }
    typedi_1.Container.set(http_client_base_1.N9HttpClient, new http_client_base_1.N9HttpClient(logger, options.httpClient));
    typedi_1.Container.set(N9NodeRouting.Options, options);
    if (options.apm) {
        (0, init_apm_1.initAPM)(options.apm, logger);
    }
    // Execute all *.init.ts files in modules before app started listening on the HTTP Port
    await (0, initialise_modules_1.default)(options.path, logger, options.firstSequentialInitFileNames);
    const returnObject = await ExpressApp.init(options, packageJson, logger, conf);
    Routes.init(returnObject.app, options, packageJson, environment, logger);
    // Manage SIGTERM & SIGINT
    if (options.shutdown.enableGracefulShutdown) {
        (0, register_system_signals_1.registerShutdown)(logger, options.shutdown, returnObject.server);
    }
    // Execute all *.started.ts files in modules after app started listening on the HTTP Port
    await (0, start_modules_1.default)(options.path, logger, options.firstSequentialStartFileNames);
    logger.profile('startup');
    return returnObject;
};
//# sourceMappingURL=index.js.map