"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initAPM = void 0;
const express = require("express");
function initAPM(options, log) {
    if (options.type === 'newRelic') {
        log.info(`Enable NewRelic for app ${options.newRelicOptions.appName}`);
        // eslint-disable-next-line @typescript-eslint/no-var-requires,global-require
        const newRelic = require('newrelic');
        newRelic.instrumentLoadedModule('express', express);
        try {
            // eslint-disable-next-line @typescript-eslint/no-var-requires,global-require,import/no-extraneous-dependencies
            const mongodb = require('mongodb');
            newRelic.instrumentLoadedModule('mongodb', mongodb);
        }
        catch (e) {
            log.debug(`MongoDB module is not instrumented`);
        }
    }
}
exports.initAPM = initAPM;
//# sourceMappingURL=init-apm.js.map