"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrometheusInterceptor = void 0;
const routing_controllers_1 = require("@benjd90/routing-controllers");
const PrometheusClient = require("prom-client");
const typedi_1 = require("typedi");
let PrometheusInterceptor = class PrometheusInterceptor {
    constructor() {
        this.httpRequestInFlightGauge = new PrometheusClient.Gauge({
            name: 'http_request_in_flight_total',
            help: 'A gauge of requests currently being served by the app',
            labelNames: ['method'],
        });
    }
    use(request, response, next) {
        this.httpRequestInFlightGauge.labels(request.method).inc(1);
        response.on('finish', () => {
            this.httpRequestInFlightGauge.labels(request.method).dec(1);
        });
        next();
    }
};
exports.PrometheusInterceptor = PrometheusInterceptor;
exports.PrometheusInterceptor = PrometheusInterceptor = __decorate([
    (0, typedi_1.Service)(),
    (0, routing_controllers_1.Middleware)({ type: 'before' }),
    __metadata("design:paramtypes", [])
], PrometheusInterceptor);
//# sourceMappingURL=prometheus.interceptor.js.map