"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SentryTracingInterceptor = void 0;
const routing_controllers_1 = require("@benjd90/routing-controllers");
const Sentry = require("@sentry/node");
const typedi_1 = require("typedi");
const N9NodeRouting = require("../models/routing");
let SentryTracingInterceptor = class SentryTracingInterceptor {
    constructor(n9NodeRoutingOptions) {
        this.n9NodeRoutingOptions = n9NodeRoutingOptions;
        if (this.n9NodeRoutingOptions.sentry) {
            this.tracingHandler = Sentry.Handlers.tracingHandler();
        }
    }
    use(request, response, next) {
        if (this.tracingHandler) {
            this.tracingHandler(request, response, next);
        }
        else {
            next();
        }
    }
};
exports.SentryTracingInterceptor = SentryTracingInterceptor;
exports.SentryTracingInterceptor = SentryTracingInterceptor = __decorate([
    (0, typedi_1.Service)(),
    (0, routing_controllers_1.Middleware)({ type: 'before' }),
    __metadata("design:paramtypes", [N9NodeRouting.Options])
], SentryTracingInterceptor);
//# sourceMappingURL=sentry-tracing.interceptor.js.map