import { ClassTransformOptions as ClassTransformOptionsInterface } from 'class-transformer';
import { TargetMap as TargetMapInterface } from 'class-transformer/types/interfaces/target-map.interface';
import { AnyFunction } from './utils';
export declare class ClassTransformOptionsTargetMap implements TargetMapInterface {
    target: AnyFunction;
    properties: {
        [key: string]: AnyFunction;
    };
}
export declare class ClassTransformOptions implements ClassTransformOptionsInterface {
    strategy?: 'excludeAll' | 'exposeAll';
    excludeExtraneousValues?: boolean;
    groups?: string[];
    version?: number;
    excludePrefixes?: string[];
    ignoreDecorators?: boolean;
    targetMaps?: ClassTransformOptionsTargetMap[];
    enableCircularCheck?: boolean;
    enableImplicitConversion?: boolean;
    exposeDefaultValues?: boolean;
    exposeUnsetFields?: boolean;
}
