import { ExtendConfigKeyFormat, N9ConfMergeStrategy, N9ConfOptions } from '@neo9/n9-node-conf';
import { PartialDeep } from 'type-fest';
import { N9NodeRouting } from '../../..';
export declare class N9NodeConfOptionsExtendConfigPath {
    absolute?: string;
    relative?: string;
}
declare class N9NodeConfOptionsExtendConfigKey {
    name?: string;
    format?: ExtendConfigKeyFormat;
}
export declare class N9NodeConfOptionsExtendConfig {
    path: N9NodeConfOptionsExtendConfigPath;
    key?: N9NodeConfOptionsExtendConfigKey;
    mergeStrategy?: N9ConfMergeStrategy;
}
export declare class N9NodeConfOptionsOverride<ConfType extends N9NodeRouting.N9NodeRoutingBaseConf> {
    value: PartialDeep<ConfType> | PartialDeep<N9NodeRouting.N9NodeRoutingBaseConf>;
    mergeStrategy?: N9ConfMergeStrategy;
}
export declare class N9NodeConfOptions<ConfType extends N9NodeRouting.N9NodeRoutingBaseConf> implements N9ConfOptions {
    path?: string;
    extendConfig?: N9NodeConfOptionsExtendConfig;
    overridePackageJsonDirPath?: string;
    /**
     * Override the conf at the end of loading.
     */
    override?: N9NodeConfOptionsOverride<ConfType>;
}
export {};
