import { RoutingControllersOptions as RoutingControllersOptionsInterface } from '@benjd90/routing-controllers';
import { AuthorizationChecker } from '@benjd90/routing-controllers/types/AuthorizationChecker';
import { CurrentUserChecker } from '@benjd90/routing-controllers/types/CurrentUserChecker';
import { ValidatorOptions } from 'class-validator';
import { Class } from 'type-fest';
import { ClassTransformOptions } from './class-transform-options.implementation';
export declare class RoutingControllersOptionsDefaultsParamOptions {
    required?: boolean;
}
export declare class RoutingControllersOptionsDefaults {
    nullResultCode?: number;
    undefinedResultCode?: number;
    paramOptions?: RoutingControllersOptionsDefaultsParamOptions;
}
export declare class RoutingControllersOptions implements RoutingControllersOptionsInterface {
    cors?: boolean | object;
    routePrefix?: string;
    controllers?: [] | string[];
    middlewares?: Class<unknown>[] | string[];
    interceptors?: Class<unknown>[] | string[];
    classTransformer?: boolean;
    classToPlainTransformOptions?: ClassTransformOptions;
    plainToClassTransformOptions?: ClassTransformOptions;
    validation?: boolean | ValidatorOptions;
    development?: boolean;
    defaultErrorHandler?: boolean;
    errorOverridingMap?: {
        [key: string]: any;
    };
    authorizationChecker?: AuthorizationChecker;
    currentUserChecker?: CurrentUserChecker;
    defaults?: RoutingControllersOptionsDefaults;
}
