import { NodeOptions as SentryNodeOptionsInterface } from '@sentry/node';
import { BaseTransportOptions, Breadcrumb, BreadcrumbHint, CaptureContext, Event, EventHint, Integration, Options as SentryNodeOptionsOptionsInterface, SamplingContext, SdkMetadata, Transport } from '@sentry/types';
declare class Options implements SentryNodeOptionsOptionsInterface {
    debug?: boolean;
    enabled?: boolean;
    dsn?: string;
    defaultIntegrations?: false | Integration[];
    integrations?: Integration[] | ((integrations: Integration[]) => Integration[]);
    ignoreErrors?: (string | RegExp)[];
    transport?: (transportOptions: BaseTransportOptions) => Transport;
    tunnel?: string;
    release?: string;
    environment?: string;
    dist?: string;
    maxBreadcrumbs?: number;
    sampleRate?: number;
    attachStacktrace?: boolean;
    maxValueLength?: number;
    normalizeDepth?: number;
    shutdownTimeout?: number;
    tracesSampleRate?: number;
    autoSessionTracking?: boolean;
    initialScope?: CaptureContext;
    _metadata?: SdkMetadata;
    _experiments?: {
        [key: string]: any;
    };
    tracesSampler?(samplingContext: SamplingContext): number | boolean;
    beforeSend?(event: Event, hint?: EventHint): PromiseLike<Event | null> | Event | null;
    beforeBreadcrumb?(breadcrumb: Breadcrumb, hint?: BreadcrumbHint): Breadcrumb | null;
}
export declare class NodeOptions extends Options implements SentryNodeOptionsInterface {
    serverName?: string;
    shutdownTimeout?: number;
    httpProxy?: string;
    httpsProxy?: string;
    caCerts?: string;
    frameContextLines?: number;
    onFatalError?(error: Error): void;
}
export {};
