import { Options as GotOptions } from 'got';
export type HttpClientGotOptions = Omit<GotOptions, 'method'>;
export declare class HttpClientSensitiveHeadersOptions {
    /**
     * Should the given sensitive headers be altered.
     *
     * @default true
     */
    alterSensitiveHeaders?: boolean;
    /**
     * String or regexp to use to match the value to alter. All matching characters will be replaced with an asterisk.
     *
     * @default /(?!^)[\s\S](?!$)/ (replace all characters except for the first and last)
     */
    alteringFormat?: string | RegExp;
    /**
     * Headers to alter.
     *
     * @default ['Authorization']
     */
    sensitiveHeaders?: string[];
}
export declare class HttpClientOptions {
    /**
     * Default Got options.
     */
    gotOptions?: HttpClientGotOptions;
    /**
     * Options for handling sensitive headers.
     */
    sensitiveHeadersOptions?: HttpClientSensitiveHeadersOptions;
}
