import { N9Log } from '@neo9/n9-node-log';
import { Express } from 'express';
import * as morgan from 'morgan';
import { N9NodeRoutingBaseConf } from './base-conf';
import { RoutingControllersOptions } from './implementations/routing-controllers-options.implementation';
import { Options } from './options';
import { BodyParserOptions } from './options-bodyparser';
import { PingDb } from './options-pingdb';
export interface HttpHookArguments<ConfType> {
    expressApp: Express;
    log: N9Log;
    options: Options<ConfType>;
    conf: ConfType;
}
declare class HttpPing {
    dbs?: PingDb[];
}
export declare class HttpOptions<ConfType extends N9NodeRoutingBaseConf = N9NodeRoutingBaseConf> {
    ping?: HttpPing;
    logLevel?: string | false | morgan.FormatFn;
    port?: number | string;
    preventListen?: boolean;
    routingController?: RoutingControllersOptions;
    beforeRoutingControllerLaunchHook?: (args: HttpHookArguments<ConfType>) => Promise<void> | void;
    afterRoutingControllerLaunchHook?: (args: HttpHookArguments<ConfType>) => Promise<void> | void;
    bodyParser?: BodyParserOptions;
}
export {};
