import { RequestHandlerOptions } from '@sentry/node/types/handlers';
import { NodeOptions } from './implementations/sentry-node-options.implementation';
export declare class MiddlewareErrorOutput {
    statusCode?: number | string;
}
export declare class SentryOptionsIntegration {
    kind: string;
}
/**
 * Model of errors from Sentry
 */
export declare class MiddlewareError extends Error {
    status?: number | string;
    statusCode?: number | string;
    status_code?: number | string;
    output?: MiddlewareErrorOutput;
}
export declare class SentryOptionsAdditionalIntegrationsOptions {
    methods?: ('all' | 'get' | 'head' | 'post' | 'put' | 'delete' | 'options' | 'trace' | 'patch')[];
}
export declare class SentryOptionsAdditionalIntegrations extends SentryOptionsIntegration {
    kind: 'tracing';
    options?: SentryOptionsAdditionalIntegrationsOptions;
}
export declare class SentryErrorHandlerOptions {
    shouldHandleError?: (error: MiddlewareError) => boolean;
}
export declare class SentryOptions {
    initOptions?: NodeOptions;
    forceCustomOptions?: boolean;
    additionalIntegrations?: SentryOptionsAdditionalIntegrations[];
    requestHandlerOptions?: RequestHandlerOptions;
    errorHandlerOptions?: SentryErrorHandlerOptions;
}
