"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SentryOptions = exports.SentryErrorHandlerOptions = exports.SentryOptionsAdditionalIntegrations = exports.SentryOptionsAdditionalIntegrationsOptions = exports.MiddlewareError = exports.SentryOptionsIntegration = exports.MiddlewareErrorOutput = void 0;
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
const string_or_number_validator_1 = require("../../validators/string-or-number.validator");
const sentry_node_options_implementation_1 = require("./implementations/sentry-node-options.implementation");
class MiddlewareErrorOutput {
}
exports.MiddlewareErrorOutput = MiddlewareErrorOutput;
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, string_or_number_validator_1.isStringOrNumber)(),
    __metadata("design:type", Object)
], MiddlewareErrorOutput.prototype, "statusCode", void 0);
class SentryOptionsIntegration {
}
exports.SentryOptionsIntegration = SentryOptionsIntegration;
__decorate([
    (0, class_validator_1.IsString)(),
    __metadata("design:type", String)
], SentryOptionsIntegration.prototype, "kind", void 0);
/**
 * Model of errors from Sentry
 */
class MiddlewareError extends Error {
}
exports.MiddlewareError = MiddlewareError;
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, string_or_number_validator_1.isStringOrNumber)(),
    __metadata("design:type", Object)
], MiddlewareError.prototype, "status", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, string_or_number_validator_1.isStringOrNumber)(),
    __metadata("design:type", Object)
], MiddlewareError.prototype, "statusCode", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, string_or_number_validator_1.isStringOrNumber)()
    // eslint-disable-next-line @typescript-eslint/naming-convention
    ,
    __metadata("design:type", Object)
], MiddlewareError.prototype, "status_code", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => MiddlewareErrorOutput),
    __metadata("design:type", MiddlewareErrorOutput)
], MiddlewareError.prototype, "output", void 0);
class SentryOptionsAdditionalIntegrationsOptions {
}
exports.SentryOptionsAdditionalIntegrationsOptions = SentryOptionsAdditionalIntegrationsOptions;
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.IsString)(),
    (0, class_validator_1.IsIn)(['all', 'get', 'head', 'post', 'put', 'delete', 'options', 'trace', 'patch']),
    __metadata("design:type", Array)
], SentryOptionsAdditionalIntegrationsOptions.prototype, "methods", void 0);
class SentryOptionsAdditionalIntegrations extends SentryOptionsIntegration {
}
exports.SentryOptionsAdditionalIntegrations = SentryOptionsAdditionalIntegrations;
__decorate([
    (0, class_validator_1.IsString)(),
    (0, class_validator_1.IsIn)(['tracing']),
    __metadata("design:type", String)
], SentryOptionsAdditionalIntegrations.prototype, "kind", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => SentryOptionsAdditionalIntegrationsOptions),
    __metadata("design:type", SentryOptionsAdditionalIntegrationsOptions)
], SentryOptionsAdditionalIntegrations.prototype, "options", void 0);
class SentryErrorHandlerOptions {
}
exports.SentryErrorHandlerOptions = SentryErrorHandlerOptions;
class SentryOptions {
}
exports.SentryOptions = SentryOptions;
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => sentry_node_options_implementation_1.NodeOptions),
    __metadata("design:type", sentry_node_options_implementation_1.NodeOptions)
], SentryOptions.prototype, "initOptions", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsBoolean)(),
    __metadata("design:type", Boolean)
], SentryOptions.prototype, "forceCustomOptions", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.ValidateNested)({ each: true }),
    (0, class_transformer_1.Type)(() => SentryOptionsAdditionalIntegrations),
    __metadata("design:type", Array)
], SentryOptions.prototype, "additionalIntegrations", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.Allow)(),
    __metadata("design:type", Object)
], SentryOptions.prototype, "requestHandlerOptions", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => SentryErrorHandlerOptions),
    __metadata("design:type", SentryErrorHandlerOptions)
], SentryOptions.prototype, "errorHandlerOptions", void 0);
//# sourceMappingURL=options-sentry.js.map