import { N9Log } from '@neo9/n9-node-log';
import { N9NodeRoutingBaseConf } from './base-conf';
import { N9LogOptions } from './implementations/n9-node-log.implementation';
import { APMOptions } from './options-apm';
import { ConfOptions } from './options-conf';
import { HttpOptions } from './options-http';
import { HttpClientOptions } from './options-http-client';
import { PrometheusOptions } from './options-prometheus';
import { SentryOptions } from './options-sentry';
import { ShutdownOptions } from './options-shutdown';
import { SwaggerOptions } from './options-swagger';
export declare class Options<ConfType extends N9NodeRoutingBaseConf = N9NodeRoutingBaseConf> {
    hasProxy?: boolean;
    enableRequestId?: boolean;
    enableLogFormatJSON?: boolean;
    path?: string;
    conf?: ConfOptions<ConfType>;
    log?: N9Log;
    logOptions?: N9LogOptions;
    http?: HttpOptions<ConfType>;
    httpClient?: HttpClientOptions;
    openapi?: SwaggerOptions;
    shutdown?: ShutdownOptions;
    prometheus?: PrometheusOptions;
    sentry?: SentryOptions;
    apm?: APMOptions;
    firstSequentialInitFileNames?: string[];
    firstSequentialStartFileNames?: string[];
}
