"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Options = void 0;
const n9_node_log_1 = require("@neo9/n9-node-log");
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
const n9_node_log_implementation_1 = require("./implementations/n9-node-log.implementation");
const options_apm_1 = require("./options-apm");
const options_conf_1 = require("./options-conf");
const options_http_1 = require("./options-http");
const options_http_client_1 = require("./options-http-client");
const options_prometheus_1 = require("./options-prometheus");
const options_sentry_1 = require("./options-sentry");
const options_shutdown_1 = require("./options-shutdown");
const options_swagger_1 = require("./options-swagger");
class Options {
}
exports.Options = Options;
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsBoolean)(),
    __metadata("design:type", Boolean)
], Options.prototype, "hasProxy", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsBoolean)(),
    __metadata("design:type", Boolean)
], Options.prototype, "enableRequestId", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsBoolean)(),
    __metadata("design:type", Boolean)
], Options.prototype, "enableLogFormatJSON", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsString)(),
    __metadata("design:type", String)
], Options.prototype, "path", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => options_conf_1.ConfOptions),
    __metadata("design:type", options_conf_1.ConfOptions)
], Options.prototype, "conf", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.Allow)(),
    __metadata("design:type", n9_node_log_1.N9Log)
], Options.prototype, "log", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => n9_node_log_implementation_1.N9LogOptions),
    __metadata("design:type", n9_node_log_implementation_1.N9LogOptions)
], Options.prototype, "logOptions", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => options_http_1.HttpOptions),
    __metadata("design:type", options_http_1.HttpOptions)
], Options.prototype, "http", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => options_http_client_1.HttpClientOptions),
    __metadata("design:type", options_http_client_1.HttpClientOptions)
], Options.prototype, "httpClient", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => options_swagger_1.SwaggerOptions),
    __metadata("design:type", options_swagger_1.SwaggerOptions)
], Options.prototype, "openapi", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => options_shutdown_1.ShutdownOptions),
    __metadata("design:type", options_shutdown_1.ShutdownOptions)
], Options.prototype, "shutdown", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => options_prometheus_1.PrometheusOptions),
    __metadata("design:type", options_prometheus_1.PrometheusOptions)
], Options.prototype, "prometheus", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => options_sentry_1.SentryOptions),
    __metadata("design:type", options_sentry_1.SentryOptions)
], Options.prototype, "sentry", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => options_apm_1.APMOptions),
    __metadata("design:type", options_apm_1.APMOptions)
], Options.prototype, "apm", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.IsString)({ each: true }),
    __metadata("design:type", Array)
], Options.prototype, "firstSequentialInitFileNames", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.IsString)({ each: true }),
    __metadata("design:type", Array)
], Options.prototype, "firstSequentialStartFileNames", void 0);
//# sourceMappingURL=options.js.map