"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setRequestContext = exports.requestIdFilter = exports.RequestIdKey = exports.RequestIdNamespaceName = void 0;
const cls_hooked_1 = require("cls-hooked");
const nanoid_1 = require("nanoid");
// eslint-disable-next-line @typescript-eslint/naming-convention
const RequestIdNamespaceName = 'requestIdNamespace';
exports.RequestIdNamespaceName = RequestIdNamespaceName;
// eslint-disable-next-line @typescript-eslint/naming-convention
const RequestIdKey = 'request-id';
exports.RequestIdKey = RequestIdKey;
(0, cls_hooked_1.createNamespace)(RequestIdNamespaceName);
function requestIdFilter({ message, context, options }) {
    const formatLogInJSON = options.formatJSON ?? false;
    const namespaceRequestId = (0, cls_hooked_1.getNamespace)(RequestIdNamespaceName);
    const requestId = namespaceRequestId?.get(RequestIdKey);
    if (formatLogInJSON) {
        if (requestId) {
            return {
                context: {
                    requestId,
                    ...context,
                },
            };
        }
    }
    return { message: requestId ? `(${requestId}) ${message}` : message };
}
exports.requestIdFilter = requestIdFilter;
function setRequestContext(req, res, next) {
    let requestId = req.headers['x-request-id'];
    if (!requestId) {
        requestId = (0, nanoid_1.nanoid)(10);
    }
    const namespaceRequestId = (0, cls_hooked_1.getNamespace)(RequestIdNamespaceName);
    namespaceRequestId.run(() => {
        namespaceRequestId.set(RequestIdKey, requestId);
        next();
    });
}
exports.setRequestContext = setRequestContext;
//# sourceMappingURL=requestid.js.map