"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRoutes = exports.addRoute = void 0;
const routing_controllers_1 = require("@benjd90/routing-controllers");
const aclDescriptions = [];
function addRoute(object, methodName, perms, loadPath) {
    aclDescriptions.push({
        object,
        methodName,
        perms,
        loadPath,
    });
}
exports.addRoute = addRoute;
function getRoutes() {
    return aclDescriptions.map((d) => {
        const act = (0, routing_controllers_1.getMetadataArgsStorage)().actions.filter((action) => {
            return action.target === d.object.constructor && action.method === d.methodName;
        })[0];
        const controller = (0, routing_controllers_1.getMetadataArgsStorage)().controllers.filter((ctrl) => {
            return ctrl.target === d.object.constructor;
        });
        let controllerRoutePrefix = '';
        if (controller?.[0]?.route) {
            controllerRoutePrefix = controller[0].route;
        }
        let actRoute = '';
        if (act.route) {
            actRoute = act.route.toString();
        }
        return {
            method: act.type,
            path: controllerRoutePrefix + actRoute,
            acl: {
                perms: d.perms,
                loadPath: d.loadPath,
            },
        };
    });
}
exports.getRoutes = getRoutes;
//# sourceMappingURL=routes.service.js.map