import { TransformFnParams } from 'class-transformer';
export declare enum SecretType {
    /**
     * Secret is not exposed at all, set to undefined
     */
    INVISIBLE = "invisible",
    /**
     * Secret is replaced with *** if not nil
     */
    OPAQUE = "opaque",
    /**
     * If secret is an URI, then the password only is hidden
     */
    URI = "uri"
}
export interface SecretTransformerOptions {
    each: boolean;
}
export declare class SecretTransformer {
    private static uriRegex;
    static GET_TRANSFORMER(secretType?: SecretType, options?: SecretTransformerOptions): (params: TransformFnParams) => unknown;
    private static opaqueTransformation;
    private static makeOpaque;
    private static uriTransformation;
    private static maskUri;
}
