"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPortAvailable = exports.isNil = exports.getEnvironment = void 0;
const net = require("net");
function getEnvironment() {
    const isDevelopmentEnv = process.env.NODE_ENV && process.env.NODE_ENV === 'development';
    return isDevelopmentEnv ? 'development' : process.env.NODE_ENV;
}
exports.getEnvironment = getEnvironment;
function isNil(value) {
    return value === undefined || value === null;
}
exports.isNil = isNil;
async function isPortAvailable(port) {
    // src: https://github.com/sindresorhus/get-port/blob/main/index.js#L56
    return await new Promise((resolve) => {
        const server = net.createServer();
        server.unref();
        server.on('error', () => resolve(false));
        server.listen({ port }, () => {
            server.close(() => {
                resolve(true);
            });
        });
    });
}
exports.isPortAvailable = isPortAvailable;
//# sourceMappingURL=utils.js.map