"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpCargoBuilder = void 0;
const typedi_1 = require("typedi");
const cargo_1 = require("./cargo");
const http_client_base_1 = require("./http-client-base");
class HttpCargoBuilder {
    static BUILD(cargoOptions, urlGetMultiple, keyName, objectKey = '_id') {
        const httpClient = typedi_1.Container.get(http_client_base_1.N9HttpClient);
        cargoOptions.workerFn =
            cargoOptions.workerFn ??
                (async (keyValues) => await httpClient.get(urlGetMultiple, {
                    [keyName]: keyValues,
                }));
        cargoOptions.dispatchFn =
            cargoOptions.dispatchFn ??
                ((request, responses) => {
                    return responses.items.find((response) => response[objectKey] === request);
                });
        return new cargo_1.Cargo(`http-${cargoOptions.cargoType}`, cargoOptions.workerFn, cargoOptions.dispatchFn, cargoOptions.throwOnEmptyValue, cargoOptions.nbMaxConcurrentWorkers, cargoOptions.taskPerWorker);
    }
}
exports.HttpCargoBuilder = HttpCargoBuilder;
//# sourceMappingURL=http-cargo-builder.js.map